var ScreenWidth = 960;
var ScreenHeight = 540;

var VideoWidth = 0;
var VideoHeight = 0;
var VideoDuration = 0;
var modeName="";

var Player = {
	plugin : null,
	state : -1,
	stopCallback : null,

	STOPPED : 0,
	PLAYING : 1,
	PAUSED : 2,
	FORWARD : 3,
	REWIND : 4,
	duration : 0,
    current_time : 0,
	arr_c_pleer : ["C","D","B"], // перечень где используеться старый плеер
	resumeTime : new Array(),
	seekTime : 0,
	maxResumeTimeCount : 20,
	minDuration : 600000, // 10 мин.
};

Player.init = function() {
	var success = true;
	this.state = this.STOPPED;
	if(Player.arr_c_pleer.indexOf(Main.hardware_char)>-1){
		this.plugin = document.getElementById("pluginPlayer");
        if (!this.plugin )
        {
        	Player.setWindow();
            success = false;
        }
		this.plugin.OnCurrentPlayTime = 'Player.setCurTime';
		this.plugin.OnStreamInfoReady = 'Player.OnStreamInfoReady';
		this.plugin.OnBufferingStart = 'Player.onBufferingStart';
		this.plugin.OnBufferingProgress = 'Player.onBufferingProgress';
		this.plugin.OnBufferingComplete = 'Player.onBufferingComplete';
	} else {
		Player.plugin = document.getElementById("PluginSef");
			if (!Player.plugin )
			{
				Player.setWindow();
				success = false;
			}
		Player.plugin.Open('Player', '1.010', 'Player');
		Player.plugin.OnEvent = 'Player.onPlayerEvent';
	}
	
	Player.readResumeTime();
	
	return success;
};

Player.deinit = function()
{
	if (Player.plugin) {
		if(Player.arr_c_pleer.indexOf(Main.hardware_char)>-1){
			this.plugin.Stop();
		} else {
			Player.plugin.Execute('Stop');
		}
	}
};

// переключение типа полноэкранного режима, значения от 1 до 3
Player.setScreenMode = function(modesize) {
	if (VideoWidth <= 0 || VideoHeight <= 0) {return -1;}
	
	var wCorr = VideoWidth < (VideoHeight * 4 / 3) ? VideoHeight * 4 / 3 : VideoWidth ;
	
	var crop = {
		x : 0,
		y : 0,
		w : VideoWidth ,
		h : VideoHeight
	};
	
	var disp = {
		x : 0,
		y : 0,
		w : ScreenWidth,
		h : ScreenHeight
	};
 
  //  var result = modesize;//((!modesize) ? 1 : modesize) + "";
   
	switch (modesize) {
	case 1:
		if ( VideoWidth/VideoHeight < 16/9 ) {
			modeName="FullScreen 4x3";
			var h1 = wCorr * 9 / 16;
			crop = {
				x : 0,
				y : parseInt( (VideoHeight - h1) / 2),
				w : VideoWidth ,
				h : parseInt(h1)
			};
		} else {
			modeName="FullScreen 16x9";
			var w1 = VideoHeight * 16 / 9;
			crop = {
				x : parseInt( (VideoWidth - w1) / 2),
				y : 0,
				w : parseInt(w1),
				h : VideoHeight
			};
		}
		break;
	case 2:
		if (VideoWidth/VideoHeight < 16/9 ) {
			modeName="Original 4x3";
			var h1 = ScreenHeight;
			var w1 = h1 * wCorr / VideoHeight;
			var x = (ScreenWidth - w1) / 2;
			if (x < 0)
				x = 0;
			disp = {
				x : parseInt(x),
				y : 0,
				w : parseInt(w1),
				h : parseInt(h1)
			};
		} else {
			modeName="Original 16x9";
			var w1 = ScreenWidth;
			var h1 = w1 * VideoHeight / VideoWidth;
			var y = (ScreenHeight - h1) / 2;
			if (y < 0)
				y = 0;
			disp = {
				x : 0,
				y : parseInt(y),
				w : parseInt(w1),
				h : parseInt(h1)
			};
		}
		;
		break;
	case 3:
		modeName="FullScreen 14x9";
		crop = {
			x : 0,
			y : parseInt(0.0625 * VideoHeight),
			w : VideoWidth ,
			h : parseInt(0.875 * VideoHeight)
		};
		break;
	default:
		break;
}

	if(Player.arr_c_pleer.indexOf(Main.hardware_char)>-1){
		this.plugin.SetCropArea(crop.x, crop.y, crop.w, crop.h);
		this.plugin.SetDisplayArea(disp.x, disp.y, disp.w, disp.h);
	} else {
		Player.plugin.Execute("SetCropArea", crop.x, crop.y, crop.w, crop.h);
		Player.plugin.Execute('SetDisplayArea',disp.x,disp.y,disp.w,disp.h);
	}
	
	currentStatusLineText = modeName + " (" + crop.w + "x" + crop.h + ")";
	Display.statusLine (currentStatusLineText);

	if (this.state == this.PAUSED) {Player.plugin.Execute('Pause');}
};

Player.playVideo = function() // играть
{
	pluginAPI.unregistKey(tvKey.KEY_TOOLS);
	this.state = this.PLAYING;
	Main.setFullScreenMode();
	Display.music();
	if(Player.arr_c_pleer.indexOf(Main.hardware_char)>-1){
		alert ("player C");
		if(this.seekTime > 0 && Main.sta == 2) {
			this.plugin.ResumePlay(url, this.seekTime);
		} else {
			this.plugin.Play(url);
		}
	} else {
		alert ("player SEF");
		Player.plugin.Execute('InitPlayer',url);
		if(this.seekTime > 0 && Main.sta == 2) {
			Player.plugin.Execute('StartPlayback',this.seekTime);
		} else {
			Player.plugin.Execute('StartPlayback');
		}
	}
};

Player.onPlayerEvent = function(e,a)
{
	switch(e)
	{
		case 9:// OnStreamInfoReady
			Video = "<"+Player.plugin.Execute ("GetVideoResolution", 1)+">";
			Video = Video.replace("|","><");
			myRe = new RegExp("\<(.*)\>\<(.*)\>","igm");
				while (rozm = myRe.exec(Video)) {
					VideoWidth=rozm[1];
					VideoHeight=rozm[2];
				}
			Player.setScreenMode(currentFSMode);
			VideoDuration = Player.plugin.Execute('GetDuration');
			Display.setTotalTime(VideoDuration);
		break;
		case 11: // OnBufferingStart
		   Player.onBufferingStart(a);
		break;
		case 12: // OnBufferingComplete
		   Player.onBufferingComplete(a);
		break;	
		case 13: // OnBufferingProgress, param = progress in % 
			Player.onBufferingProgress(a);
		break;
		case 14:// OnCurrentPlayBackTime, param = playback time in ms
			Player.setCurTime(a);
		break;
	};
};

Player.setWindow = function() // видео скрыто
{
	if(Player.arr_c_pleer.indexOf(Main.hardware_char)>-1){
		this.plugin.SetDisplayArea(0, 0, 0, 0);
	} else {
		Player.plugin.Execute('SetDisplayArea',0,0,0,0);
	}
};

Player.setFullscreen = function() // полноэкранный режим
{
	if(Player.arr_c_pleer.indexOf(Main.hardware_char)>-1){
		this.plugin.SetDisplayArea(0, 0, ScreenWidth, ScreenHeight);
	} else {
		Player.plugin.Execute('SetDisplayArea',0,0,ScreenWidth,ScreenHeight);
	}
};

Player.pauseVideo = function() // пауза
{
	this.state = this.PAUSED;
	if(Player.arr_c_pleer.indexOf(Main.hardware_char)>-1){
		this.plugin.Pause();
	} else {
		Player.plugin.Execute('Pause');
	}
	Display.showplayer();
	document.getElementById("but_pause").style.display="block";
	document.getElementById("but_play").style.display="none";
};

Player.stopVideo = function() // стоп
{
	if (this.state != this.STOPPED) {
		pluginAPI.registKey(tvKey.KEY_TOOLS);
		if(Player.arr_c_pleer.indexOf(Main.hardware_char)>-1){
			this.plugin.Stop();
		} else {
			Player.plugin.Execute('Stop');	
		}
		this.state = this.STOPPED;
		document.getElementById("progressBar").style.width = "0px";
		Display.setTime(0);
		Player.saveResumeTime();
	}
};

Player.resumeVideo = function() // стоп кадр
{
	this.state = this.PLAYING;
	if(Player.arr_c_pleer.indexOf(Main.hardware_char)>-1){
		this.plugin.Resume();
	} else {
		Player.plugin.Execute('Resume');
	}
    Display.showplayer();
	document.getElementById("but_pause").style.display="none";
	document.getElementById("but_play").style.display="block";
};

Player.getState = function() // текущее состояние
{
	return this.state;
};

Player.skipForwardVideo = function() {
	this.skipState = this.FORWARD;
	if(Player.arr_c_pleer.indexOf(Main.hardware_char)>-1){
		this.plugin.JumpForward(30);
	} else {
		Player.plugin.Execute('JumpForward',30);
	}
	Display.showplayer();
};

Player.skipForwardVideoFast = function() {
	this.skipState = this.FORWARD;
	if(Player.arr_c_pleer.indexOf(Main.hardware_char)>-1){
		this.plugin.JumpForward(120);
	} else {
		Player.plugin.Execute('JumpForward',120);
	}
	Display.showplayer();
};

Player.skipBackwardVideo = function() {
	this.skipState = this.REWIND;
	if(Player.arr_c_pleer.indexOf(Main.hardware_char)>-1){
		this.plugin.JumpBackward(30);
	} else {
		Player.plugin.Execute('JumpBackward',30);
	}
	Display.showplayer();
};

Player.skipBackwardVideoFast = function() {
	this.skipState = this.REWIND;
	if(Player.arr_c_pleer.indexOf(Main.hardware_char)>-1){
		this.plugin.JumpBackward(120);
	} else {
		Player.plugin.Execute('JumpBackward',120);
	}
	Display.showplayer();
};

//Прыжок в %
Player.PercentJump = function(percent) {
	this.statusmessage = percent*10 + "%";
	var jump_to_minutes = Math.round((VideoDuration*percent/10));
	jump_to_minutes = jump_to_minutes - this.current_time;
	jump_to_minutes = jump_to_minutes / 1000;
	if(Player.arr_c_pleer.indexOf(Main.hardware_char)>-1){
		if (jump_to_minutes > 0) this.plugin.JumpForward(jump_to_minutes);
		if (jump_to_minutes < 0) this.plugin.JumpBackward(jump_to_minutes*-1);	
	} else {
		if (jump_to_minutes > 0) Player.plugin.Execute('JumpForward',jump_to_minutes);
		if (jump_to_minutes < 0) Player.plugin.Execute('JumpBackward',jump_to_minutes*-1);
	}
	widgetAPI.putInnerHTML(Display.statusDiv,(this.statusmessage));
	Display.showplayer();
};

// Перемотка вперед в %
Player.PercentJumpForward = function(percent) {
	this.statusmessage = percent + "%";
	var jump_to_minutes = Math.round((VideoDuration*percent/100));
	jump_to_minutes = jump_to_minutes / 1000;
	if(Player.arr_c_pleer.indexOf(Main.hardware_char)>-1){
		this.plugin.JumpForward(jump_to_minutes);
	} else {
		Player.plugin.Execute('JumpForward',jump_to_minutes);
	}
	widgetAPI.putInnerHTML(Display.statusDiv,(this.statusmessage));
	Display.showplayer();
};

//Перемотка назад в %
Player.PercentJumpBackward = function(percent) {
	this.statusmessage = "-" + percent + "%";
	var jump_to_minutes = Math.round((VideoDuration*percent/100));
	jump_to_minutes = jump_to_minutes / 1000;
	if(Player.arr_c_pleer.indexOf(Main.hardware_char)>-1){
		this.plugin.JumpBackward(jump_to_minutes);
	} else {	
		Player.plugin.Execute('JumpBackward',jump_to_minutes);
	}
	widgetAPI.putInnerHTML(Display.statusDiv,(this.statusmessage));
	Display.showplayer();
};

//Прыжок в сек.
Player.JumpToTime = function(time) {
	var jump_to_minutes = time / 1000;
	if(Player.arr_c_pleer.indexOf(Main.hardware_char)>-1){
		this.plugin.JumpForward(jump_to_minutes);
	} else {	
		Player.plugin.Execute('JumpForward',jump_to_minutes);
	}
	Display.showplayer();
};

// функция таймера проигрывания трека, вызывается плагином:
// plugin.OnCurrentPlayTime
Player.setCurTime = function(time) {
	this.current_time = time;
	Display.setTime(time);
};

Player.onBufferingComplete = function() 
{
   alert("onBufferingComplete");
};   

Player.onBufferingProgress = function(percent)
{
	Display.statusLine ("Buffering "+percent+"%");
	alert ("buffering progress = "+percent);
};

Player.onBufferingStart =function()
{
	alert ("buffering start");
};

Player.nextaudio = function() {
	if(Player.arr_c_pleer.indexOf(Main.hardware_char)>-1){
		Display.statusLine ("Не поддерживаеться");
	} else {
		var audio = Player.plugin.Execute('GetCurrentStreamID',1);
		var max_audio = (Player.plugin.Execute('GetTotalNumOfStreamID',1)-1);
		if (max_audio != 0) {
			if (audio != max_audio) {
				Player.plugin.Execute('SetStreamID',1,(audio+1));
				Display.statusLine ("Звуковая дорожка № "+(audio+2));
			} 
			if (audio == max_audio) {
				Player.plugin.Execute('SetStreamID','1','0');
				Display.statusLine ("Звуковая дорожка № 1");
			} 
				
		}
	}
};

Player.OnStreamInfoReady = function() {
	alert("OnStreamInfoReady");
	VideoDuration = Player.plugin.GetDuration();
	VideoWidth = Player.plugin.GetVideoWidth();
	VideoHeight = Player.plugin.GetVideoHeight();
	Display.setTotalTime(VideoDuration);
	Player.setScreenMode (currentFSMode);
};

Player.saveResumeTime = function() {

	var obj = new Object();
		
	obj.url = url;
	obj.time = this.current_time/1000; // получаем время в сек.
	
	var isAdd = true;
	
	for(var i = 0; i < this.resumeTime.length && isAdd; i++) {
		if (this.resumeTime[i].url==obj.url) {
			if(VideoDuration < this.minDuration || this.current_time/VideoDuration < 0.1 || this.current_time/VideoDuration > 0.9) {
				this.resumeTime.splice(i,1); // удаляем элемент массива
			} else {
				this.resumeTime[i].time = obj.time;
				isAdd = false;
			}
		}
	}
	
	if(VideoDuration < this.minDuration || this.current_time/VideoDuration < 0.1 || this.current_time/VideoDuration > 0.9) {
		isAdd = false;
	}

	if (isAdd) {
		this.resumeTime[this.resumeTime.length] = obj;
	}
	
	if(this.resumeTime.length > this.maxResumeTimeCount) {
		this.resumeTime.shift(); // удаляем первый элемент массива
	}
	
	var fileSystemObj = new FileSystem();
	if (!fileSystemObj.isValidCommonPath(curWidget.id)) fileSystemObj.createCommonDir(curWidget.id);
    var fileObj = fileSystemObj.openCommonFile(curWidget.id+'/fs_player.data','w');
    if (fileObj)
    {
        var str = JSON.stringify(this.resumeTime);
		fileObj.writeAll(str);
        fileSystemObj.closeCommonFile(fileObj);
    }
};

Player.readResumeTime = function() {
	var fileSystemObj = new FileSystem();
	var fileObj = fileSystemObj.openCommonFile(curWidget.id+'/fs_player.data','r');
	if (fileObj){
		var strResult = fileObj.readAll();
		if (strResult) {
			this.resumeTime = JSON.parse(strResult);
		}
		fileSystemObj.closeCommonFile(fileObj);
	}
};